#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "gwifimeter.h"
#include "callback.h"

//=========================================================
char * readfunc(const char * func , const char * par1 , char * par2 ,int dec)
{
char *tab2 ,*tab3,*tab4;
int fd1[2],co;
pid_t pid;
pipe(fd1);
 pid = fork();
  if(pid == -1)
    {
      perror("fork");
      exit(-1);
    }
  else if(pid == 0)
    {
      close(fd1[0]);
dup2(fd1[1],1);//zamykamy stdout i duplkujemy je na potoku
dup2(fd1[1],2);//zamykamy stdout i duplkujemy je na potoku

//close(fd1[1]);
      execlp(func,func,par1,par2,NULL);
      perror("execlp");
      _exit(-1);
    }
      close(fd1[1]);

tab3 = (char *) g_malloc(1);
if(tab3==0)printf("przekroczona pamiec wirtualna1\n");
*tab3='\0';
tab2 = (char *) g_malloc(1);
if(tab2==0)printf("przekroczona pamiec wirtualna1\n");
*tab2='\0';

    while(1)
{
co=read(fd1[0],tab2=(char *) g_realloc(tab2,sizeof(tab2)+1),sizeof(tab2));
if(co==0) {close(fd1[0]);tab4=tab3+strlen(tab3)-dec;*tab4='\0'; break;}
tab3 = g_realloc(tab3,strlen(tab3)+sizeof(tab2)+1);
strncat(tab3,tab2,sizeof(tab2));
bzero(tab2,sizeof(tab2));
}
    g_free(tab2);

    return tab3 ;
  // g_free(tab3);
  // printf("test\n");
}
//=========================================================
void stanbar(GtkWidget *bar , gdouble stan , char *stantext)
{
	   gdk_threads_enter();
	   gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(bar),stan);
	   gtk_progress_bar_set_text(GTK_PROGRESS_BAR(bar),stantext);
	   gdk_flush ();
	   gdk_threads_leave();
}
//********************************************************************************************
/*void toggled ( void )
{
 if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (pdata->checkbutton1)))
    {
      //  printf("Aktywny\n");
      //  gtk_widget_hide (pdata->entry_ip );
      //  gtk_widget_hide (pdata->entry_gw );
      //gtk_widget_show (pdata->entry_mac );

    } else {

     //   printf("Nie aktywny\n");
     //   gtk_widget_show (pdata->entry_ip );
     //   gtk_widget_show (pdata->entry_gw );
    // gtk_widget_hide (pdata->entry_mac );
    }
}*/
//==========================================================================
void quit( GtkWidget *widget,textset *pdata,GdkEvent  *event )
{

    g_free(pdata);

    gtk_main_quit ();
}
//==========================================================================
void sigchld_handler(int num)
{
  sigset_t set, oldset;
  pid_t pid;
  int status, exitstatus;

  /* block other incoming SIGCHLD signals */
  sigemptyset(&set);
  sigaddset(&set, SIGCHLD);
  sigprocmask(SIG_BLOCK, &set, &oldset);

  /* wait for child */
  while((pid = waitpid((pid_t)-1, &status, WNOHANG)) > 0)
    {
      if(WIFEXITED(status))
        {
          exitstatus = WEXITSTATUS(status);
        }
      else if(WIFSIGNALED(status))
        {
          exitstatus = WTERMSIG(status);
        }
      else if(WIFSTOPPED(status))
        {
          exitstatus = WSTOPSIG(status);
        }
      else
        {
        }
    }
  /* re-install the signal handler (some systems need this) */
  signal(SIGCHLD, sigchld_handler);
  /* and unblock it */
  sigemptyset(&set);
  sigaddset(&set, SIGCHLD);
  sigprocmask(SIG_UNBLOCK, &set, &oldset);
}
//==============================================================
void compresspaces(const char* S)
{
 char *s   = (char*)S;
 char prev = '1';

 while (*S)
  {
   if ((prev != ' ') || (*S != ' '))
	 *s++ = *S;

   prev = *S++;
  }
 *s = '\0';
 //return S;
}
//===============================================================
void space (char *dane)
{
int a=1;
while(1)
{
if(*(dane+a)==' '){*(dane+a)='\0';break;}
if(*(dane+a)=='\n'){*(dane+a)='\0';break;}
++a;
}
}
//==============================================================
void space2 (char *dane)
{
int a=1;
while(1)
{
//if(*(dane+a)=='\0 '){break;}
if(*(dane+a)=='\n'){*(dane+a)='\0';break;}
++a;
}
}
//============================================================
void chekuser ( void)
{

char *user;
user = readfunc("whoami",NULL,NULL,1);
pdata->user = g_realloc(pdata->user,strlen(user)+19);
strcpy(pdata->user,"/home/");
strcat(pdata->user,user);
strcat(pdata->user,"/.gwifimeter");
//printf("%s\n",pdata->user);
g_free(user);
}

//======================================================================
char * chekface ( void)
{
char *tab3,*intface,*ifaceend,*intface2;
    tab3 = readfunc(gtk_entry_get_text (GTK_ENTRY (pdata->entry_set_iwconfig)),NULL,NULL,0);
compresspaces(tab3);
//    write(1,tab3,strlen(tab3));
    intface = strstr(tab3,"ESSID");
    intface2 = strstr(tab3,"IEEE");
    if(intface != NULL )
    {
    //*(--intface)='\0';
    while(1)
    {
    --intface;
    if(*intface == '\n')break;
    }
    ifaceend = ++intface;
    while(1)
    {
    ++ifaceend;
    if(*ifaceend == ' ')break;
    }
    *ifaceend = '\0';
//    printf("\n %s \n",intface);
//    gtk_entry_set_text (GTK_ENTRY (pdata->entry_inter),intface);
    strcpy(pdata->interface,intface);
    g_free(tab3);
    return pdata->interface;
    }
    if(intface2 != NULL )
    {
    //*(--intface)='\0';
    while(1)
    {
    --intface2;
    if(*intface2 == '\n')break;
    }
    ifaceend = ++intface2;
    while(1)
    {
    ++ifaceend;
    if(*ifaceend == ' ')break;
    }
    *ifaceend = '\0';
//    printf("\n %s \n",intface);
//    gtk_entry_set_text (GTK_ENTRY (pdata->entry_inter),intface2);
    strcpy(pdata->interface,intface2);
    g_free(tab3);
    return pdata->interface;
    }
    g_free(tab3);
    strcpy(pdata->interface,"Nie_znaleziono");
    return pdata->interface;
}
void findfaceset(void)
{
gtk_entry_set_text (GTK_ENTRY (pdata->entry_set_inter),chekface());
}
