#include <signal.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include "gwifimeter.h"
#include "callback.h"
#include "textview1.h"
#include "scan.h"
#include "check.h"
#include "but_connect.h"
#include "profil.h"

int main( int   argc,
          char *argv[] )
{
   /* GtkWidget is the storage type for widgets */

    GError    *err1 = NULL ;

  if( !g_thread_supported() )/*Spawdzenie suportu dla thread*/
  {
     g_thread_init(NULL);
     gdk_threads_init();      // Called to initialize internal mutex "gdk_threads_mutex".
//     printf("g_thread supported\n");
  }
  else
  {
     printf("g_thread NOT supported\n");
  }

    /* This is called in all GTK applications. Arguments are parsed
     * from the command line and are returned to the application. */
    gtk_init (&argc, &argv);
//Przydzielamy pami dla struktury
    pdata = g_malloc (sizeof (textset));
    /* tworzymy GUI */
//-------------------------------------------------------------
    pdata->window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request (pdata->window, 500, 340);
    gtk_window_set_title (GTK_WINDOW (pdata->window),("Gwifimeter"));
    gtk_container_set_border_width (GTK_CONTAINER (pdata->window), 10);
    pdata->notebook1 = gtk_notebook_new ();
    gtk_container_add (GTK_CONTAINER (pdata->window), pdata->notebook1);


    pdata->vbox1 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->notebook1), pdata->vbox1);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox1), 10);
/*    pdata->menubar1 = gtk_menu_bar_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox1), pdata->menubar1, FALSE, FALSE, 0);
    pdata->menuitem4 = gtk_menu_item_new_with_mnemonic ("Opcje");
    gtk_container_add (GTK_CONTAINER (pdata->menubar1), pdata->menuitem4);
    pdata->menu4 = gtk_menu_new ();
    gtk_menu_item_set_submenu (GTK_MENU_ITEM (pdata->menuitem4), pdata->menu4);
    pdata->opcje = gtk_menu_item_new_with_mnemonic ("ustawienia");
    gtk_container_add (GTK_CONTAINER (pdata->menu4), pdata->opcje);
    pdata->koniec = gtk_menu_item_new_with_mnemonic ("Koniec");
    gtk_container_add (GTK_CONTAINER (pdata->menu4), pdata->koniec);
    pdata->menuitem5 = gtk_menu_item_new_with_mnemonic ("Pomoc");
    gtk_container_add (GTK_CONTAINER (pdata->menubar1), pdata->menuitem5);
    pdata->menu5 = gtk_menu_new ();
    gtk_menu_item_set_submenu (GTK_MENU_ITEM (pdata->menuitem5), pdata->menu5);
    pdata->informacje = gtk_menu_item_new_with_mnemonic ("Informacje o");
    gtk_container_add (GTK_CONTAINER (pdata->menu5), pdata->informacje);*/
//--------------------zakladka status---------------------
    pdata->label1 = gtk_label_new ("Wydruk z iwconfig");
    gtk_box_pack_start (GTK_BOX (pdata->vbox1), pdata->label1, FALSE, FALSE, 0);
    pdata->scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
    gtk_box_pack_start (GTK_BOX (pdata->vbox1), pdata->scrolledwindow1, TRUE, TRUE, 0);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (pdata->scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    pdata->textview1 = gtk_text_view_new ();
    gtk_text_view_set_editable (GTK_TEXT_VIEW (pdata->textview1), FALSE);
    gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (pdata->textview1), FALSE);
    gtk_container_add (GTK_CONTAINER (pdata->scrolledwindow1), pdata->textview1);
//    pdata->button = gtk_button_new_with_mnemonic ("koniec");
//    gtk_box_pack_start (GTK_BOX (pdata->vbox1), pdata->button, FALSE, FALSE, 0);

    pdata->progresbar1 = gtk_progress_bar_new();
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(pdata->progresbar1),"Jako\233\207 sygna\202u");
    gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR(pdata->progresbar1), GTK_PROGRESS_CONTINUOUS);
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pdata->progresbar1),1.0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox1), pdata->progresbar1, FALSE, FALSE, 0);

    pdata->progresbar0 = gtk_progress_bar_new();
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(pdata->progresbar0),"Poziom sygna\202u");
    gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR(pdata->progresbar0), GTK_PROGRESS_CONTINUOUS);
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pdata->progresbar0),1.0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox1), pdata->progresbar0, FALSE, FALSE, 0);

    pdata->progresbar2 = gtk_progress_bar_new();
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(pdata->progresbar2),"Poziom szumów");
    gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR(pdata->progresbar2), GTK_PROGRESS_CONTINUOUS);
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pdata->progresbar2),1.0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox1), pdata->progresbar2, FALSE, FALSE, 0);
    pdata->zakl1 = gtk_label_new ("status");
    gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (pdata->notebook1), 0), pdata->zakl1);
//----------------zakladka sieci---------------------

//    gtk_container_add (GTK_CONTAINER (pdata->notebook1), pdata->vbox2);
    pdata->hbox1 = gtk_hbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->notebook1), pdata->hbox1);
    pdata->vbox3 = gtk_vbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->hbox1), pdata->vbox3, TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox3), 10);
 //   gtk_widget_set_size_request (pdata->vbox3, 240, -1);
    pdata->lab_acces = gtk_label_new ("Profil");
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->lab_acces, FALSE, FALSE, 0);
    pdata->comboboxentry1 = gtk_combo_box_entry_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->comboboxentry1, FALSE, FALSE, 0);
    pdata->hbox4 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->hbox4, FALSE, FALSE, 0);
    pdata->button_set = gtk_button_new_with_mnemonic ("zapisz profil");
    gtk_box_pack_start (GTK_BOX (pdata->hbox4), pdata->button_set, TRUE, TRUE, 0);
    pdata->button_remove = gtk_button_new_with_mnemonic ("usu\204 profil");
    gtk_box_pack_start (GTK_BOX (pdata->hbox4), pdata->button_remove, TRUE, TRUE, 0);



    pdata->lab_inter = gtk_label_new ("interface sieciowy wifi");
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->lab_inter, FALSE, FALSE, 0);
    pdata->entry_inter = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->entry_inter, FALSE, FALSE, 0);
    pdata->lab_mac = gtk_label_new ("MAC adres");
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->lab_mac, FALSE, FALSE, 0);
 //   pdata->checkbutton1 = gtk_check_button_new_with_mnemonic ("Ustaw MAC adres");
 //   gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->checkbutton1, FALSE, TRUE, 0);
    pdata->hbox_mac = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->hbox_mac, FALSE, FALSE, 0);
    pdata->combobox_mac = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox_mac), pdata->combobox_mac, TRUE, TRUE, 0);
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_mac),("Brak"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_mac),("Ustaw"));
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_mac),0);
    pdata->entry_mac = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox_mac), pdata->entry_mac, TRUE, TRUE, 0);
    gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_mac), 17);
    pdata->lab_ip = gtk_label_new ("ustawiena ip");
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->lab_ip, FALSE, FALSE, 0);
    pdata->hbox_ip = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->hbox_ip, FALSE, FALSE, 0);
    pdata->combobox_ip = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox_ip), pdata->combobox_ip, TRUE, TRUE, 0);
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_ip),("Brak"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_ip),("Auto"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_ip),("Stat"));
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_ip),0);
    pdata->entry_ip = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox_ip), pdata->entry_ip, FALSE, FALSE, 0);
    gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_ip), 18);
    pdata->lab_gw = gtk_label_new (" ip gateway  ");
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->lab_gw, FALSE, FALSE, 0);
    pdata->hbox_gw = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox3), pdata->hbox_gw, FALSE, FALSE, 0);
    pdata->combobox_gw = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox_gw), pdata->combobox_gw, TRUE, TRUE, 0);
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_gw),("Brak"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_gw),("Auto"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_gw),("Stat"));
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_gw),0);
    pdata->entry_gw = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox_gw), pdata->entry_gw, FALSE, FALSE, 0);
    gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_gw), 15);

//-------------prawa strona zakladki sieci
    pdata->vbox2 = gtk_vbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->hbox1), pdata->vbox2, TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox2), 10);
//    gtk_widget_set_size_request (pdata->vbox2, 240, -1);



    pdata->lab_nazwa = gtk_label_new ("Nazwa sieci");
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->lab_nazwa, FALSE, FALSE, 0);
    pdata->entry_nazwa = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->entry_nazwa, FALSE, FALSE, 0);

    pdata->hbox6 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->hbox6, FALSE, FALSE, 0);
    pdata->button_connect = gtk_button_new_with_mnemonic ("pod\202acz sie\207");
    gtk_box_pack_start (GTK_BOX (pdata->hbox6), pdata->button_connect, TRUE, TRUE, 0);
    pdata->button_scan = gtk_button_new_with_mnemonic ("szukaj sieci");
    gtk_box_pack_start (GTK_BOX (pdata->hbox6), pdata->button_scan, TRUE, TRUE, 0);

    pdata->lab_find = gtk_label_new ("wybierz znalezion\205 sie\207");
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->lab_find, FALSE, FALSE, 0);
    pdata->comboboxentry_find = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->comboboxentry_find, FALSE, FALSE, 0);

    pdata->hbox2 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->hbox2, FALSE, FALSE, 0);
    pdata->lab_channel = gtk_label_new ("Nr Kana\202u");
    gtk_box_pack_start (GTK_BOX (pdata->hbox2), pdata->lab_channel, TRUE, TRUE, 0);
    pdata->lab_rate = gtk_label_new ("Szybko\233\207");
    gtk_box_pack_start (GTK_BOX (pdata->hbox2), pdata->lab_rate, TRUE, TRUE, 0);

    pdata->hbox3 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->hbox3, FALSE, FALSE, 0);


    pdata->comboboxentry_channel = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox3), pdata->comboboxentry_channel, TRUE, TRUE, 0);
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel Auto"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 1"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 2"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 3"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 4"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 5"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 6"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 7"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 8"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 9"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 10"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 11"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 12"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 13"));
    //gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_channel),("channel 14"));
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_channel),0);

    pdata->comboboxentry_rate = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox3), pdata->comboboxentry_rate, TRUE, TRUE, 0);
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate auto"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 1M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 2M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 5.5M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 11M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 9M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 18M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 24M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 36M"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_rate),("rate 54M"));
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_rate),0);

     pdata->hbox7 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->hbox7, FALSE, FALSE, 0);

    pdata->lab_mode = gtk_label_new ("Typ sieci");
    gtk_box_pack_start (GTK_BOX (pdata->hbox7), pdata->lab_mode, TRUE, TRUE, 0);
    pdata->lab_keymode = gtk_label_new ("zabezpieczenie");
    gtk_box_pack_start (GTK_BOX (pdata->hbox7), pdata->lab_keymode, TRUE, TRUE, 0);

    pdata->hbox8 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->hbox8, FALSE, FALSE, 0);


    pdata->comboboxentry_mode = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox8), pdata->comboboxentry_mode, TRUE, TRUE, 0);
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),("mode managed"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),("mode ad-hoc"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),("mode master"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->comboboxentry_mode),("mode monitor"));
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->comboboxentry_mode),0);

    pdata->combobox_keymode = gtk_combo_box_new_text ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox8), pdata->combobox_keymode, TRUE, TRUE, 0);
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),("Key off"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),("open"));
    gtk_combo_box_append_text (GTK_COMBO_BOX (pdata->combobox_keymode),("restricted"));
    gtk_combo_box_set_active (GTK_COMBO_BOX (pdata->combobox_keymode),0);

    pdata->lab_key = gtk_label_new ("Klucz do sieci");
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->lab_key, FALSE, FALSE, 0);
    pdata->entry_key = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox2), pdata->entry_key, FALSE, FALSE, 0);
    gtk_entry_set_max_length (GTK_ENTRY (pdata->entry_key), 26);

    pdata->net = gtk_label_new ("  sieci  ");
    gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (pdata->notebook1), 1), pdata->net);
//---------------------podglad scanowania------------------------------
    pdata->vbox5 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->notebook1), pdata->vbox5);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox5),10);
    pdata->scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
    gtk_box_pack_start (GTK_BOX (pdata->vbox5), pdata->scrolledwindow2, TRUE, TRUE, 0);

    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (pdata->scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
    gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (pdata->scrolledwindow2), GTK_SHADOW_IN);
    pdata->textview2 = gtk_text_view_new ();
    gtk_container_add (GTK_CONTAINER (pdata->scrolledwindow2), pdata->textview2);
    gtk_widget_set_size_request (pdata->textview2, 180, -1);
    gtk_text_view_set_editable (GTK_TEXT_VIEW (pdata->textview2), FALSE);
    gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (pdata->textview2), FALSE);


    pdata->seting = gtk_label_new ("podgl\205d scanowania");
    gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (pdata->notebook1), 2), pdata->seting);
//---------------------ustawienia--------------------------
    pdata->vbox_setting = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->notebook1), pdata->vbox_setting);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox_setting), 10);

    pdata->lab_set1 = gtk_label_new ("polozenie iwconfig");
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->lab_set1, FALSE, FALSE, 0);
    pdata->entry_set_iwconfig = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->entry_set_iwconfig, FALSE, FALSE, 0);

    pdata->lab_set2 = gtk_label_new ("polozenie iwlist");
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->lab_set2, FALSE, FALSE, 0);
    pdata->entry_set_iwlist = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->entry_set_iwlist, FALSE, FALSE, 0);

    pdata->lab_set3 = gtk_label_new ("polozenie klienta DHCP");
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->lab_set3, FALSE, FALSE, 0);
    pdata->entry_set_dhcp = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->entry_set_dhcp, FALSE, FALSE, 0);


    pdata->lab_set4 = gtk_label_new ("interface sieciowy wifi");
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->lab_set4, FALSE, FALSE, 0);

    pdata->hbox_set1 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->hbox_set1, FALSE, FALSE, 0);

   // pdata->vbox_setting1 = gtk_vbox_new (FALSE, 0);
   // gtk_container_add (GTK_CONTAINER (pdata->hbox_set1), pdata->vbox_setting1);
    pdata->entry_set_inter = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->hbox_set1), pdata->entry_set_inter, FALSE, FALSE, 0);

    pdata->button_set3 = gtk_button_new_with_mnemonic ("znajdz");
    gtk_box_pack_start (GTK_BOX (pdata->hbox_set1), pdata->button_set3, TRUE, TRUE, 0);

    pdata->lab_set5 = gtk_label_new ("czestotliwosc skanowania iwconfig");
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->lab_set5, FALSE, FALSE, 0);
    pdata->entry_set_timescan = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->entry_set_timescan, FALSE, FALSE, 0);

    pdata->hbox_set2 = gtk_hbox_new (FALSE, 0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox_setting), pdata->hbox_set2,FALSE, FALSE, 0);

    pdata->button_set2 = gtk_button_new_with_mnemonic ("zapisz");
    gtk_box_pack_start (GTK_BOX (pdata->hbox_set2), pdata->button_set2, TRUE, TRUE, 0);

    pdata->button_set1 = gtk_button_new_with_mnemonic ("default");
    gtk_box_pack_start (GTK_BOX (pdata->hbox_set2), pdata->button_set1, TRUE, TRUE, 0);

    pdata->zakl_setting = gtk_label_new ("ustawienia");
    gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (pdata->notebook1), 3), pdata->zakl_setting);
//---------------------zakladka o--------------------------
    pdata->vbox4 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->notebook1), pdata->vbox4);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox4), 10);
    pdata->info = gtk_label_new ("GwifiMeter 0.2.0\nCreated by Adam Strza\202kowski\nemale : gosad@op.pl");
    gtk_label_set_justify (GTK_LABEL (pdata->info), GTK_JUSTIFY_CENTER);
    gtk_container_add (GTK_CONTAINER (pdata->vbox4), pdata->info);

    pdata->zakl_o = gtk_label_new ("info_o");
    gtk_notebook_set_tab_label (GTK_NOTEBOOK (pdata->notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (pdata->notebook1), 4), pdata->zakl_o);

//----------------------------------------------------------
    pdata->window_pas = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request (pdata->window_pas, 200, 130);
    gtk_window_set_title (GTK_WINDOW (pdata->window_pas),("Podaj Has\202o"));
    gtk_container_set_border_width (GTK_CONTAINER (pdata->window_pas), 10);
    pdata->vbox_pas = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->window_pas), pdata->vbox_pas);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox_pas), 10);
    pdata->lab_pas = gtk_label_new ("Podaj Has\202o \n administratora systemu");
    gtk_label_set_justify (GTK_LABEL (pdata->lab_pas), GTK_JUSTIFY_CENTER);
    gtk_box_pack_start (GTK_BOX (pdata->vbox_pas), pdata->lab_pas, TRUE, TRUE, 0);
    pdata->entry_pas = gtk_entry_new ();
    gtk_box_pack_start (GTK_BOX (pdata->vbox_pas), pdata->entry_pas, FALSE, FALSE, 0);
    gtk_entry_set_visibility (GTK_ENTRY (pdata->entry_pas), FALSE);
    gtk_entry_set_activates_default (GTK_ENTRY (pdata->entry_pas), TRUE);
    pdata->hbox_pas = gtk_hbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->vbox_pas), pdata->hbox_pas);
    pdata->button_pas = gtk_button_new_with_mnemonic ("OK");
    gtk_box_pack_start (GTK_BOX (pdata->hbox_pas), pdata->button_pas, TRUE, TRUE, 0);
    GTK_WIDGET_SET_FLAGS (pdata->button_pas, GTK_CAN_DEFAULT);
//    gtk_widget_grab_default (GTK_BUTTON(pdata->button_pas));

    pdata->button_pas_cancel = gtk_button_new_with_mnemonic ("CANCEL");
    gtk_box_pack_start (GTK_BOX (pdata->hbox_pas), pdata->button_pas_cancel, TRUE, TRUE, 0);
//=====================================================================================
    gtk_window_set_transient_for(GTK_WINDOW (pdata->window_pas),GTK_WINDOW (pdata->window));
    gtk_window_set_position(GTK_WINDOW (pdata->window_pas),GTK_WIN_POS_CENTER_ON_PARENT);

    gtk_window_set_default(GTK_WINDOW (pdata->window_pas),pdata->button_pas);
//====================================================================================
    pdata->window_con = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request (pdata->window_con, 350, 70);
    gtk_window_set_title (GTK_WINDOW (pdata->window_con),("Postep \202\205czenia"));
    gtk_container_set_border_width (GTK_CONTAINER (pdata->window_con), 10);
    gtk_window_set_transient_for(GTK_WINDOW (pdata->window_con),GTK_WINDOW (pdata->window));
    gtk_window_set_position(GTK_WINDOW (pdata->window_con),GTK_WIN_POS_CENTER_ON_PARENT);
    pdata->vbox_con = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (pdata->window_con), pdata->vbox_con);
    gtk_container_set_border_width (GTK_CONTAINER (pdata->vbox_con), 10);
        pdata->progresbar_con = gtk_progress_bar_new();
    gtk_progress_bar_set_text(GTK_PROGRESS_BAR(pdata->progresbar_con),"Stan");
    gtk_progress_bar_set_bar_style (GTK_PROGRESS_BAR(pdata->progresbar_con), GTK_PROGRESS_CONTINUOUS);
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(pdata->progresbar_con),0);
    gtk_box_pack_start (GTK_BOX (pdata->vbox_con), pdata->progresbar_con, FALSE, FALSE, 0);
 //==================================================================================
/* pdata->mespas = gtk_message_dialog_new          (GTK_WINDOW (pdata->window),
                                             GTK_DIALOG_DESTROY_WITH_PARENT,
                                             GTK_MESSAGE_ERROR,
                                             GTK_BUTTONS_CLOSE,
                                             "Bledne Haslo");

     g_signal_connect_swapped (pdata->mespas, "response",G_CALLBACK (gtk_widget_destroy), NULL);*/
     /* Podpinam sygnały */
    g_signal_connect (G_OBJECT( pdata->window),"delete_event",G_CALLBACK (gtk_main_quit), NULL);
//    g_signal_connect (G_OBJECT (pdata->button), "clicked",G_CALLBACK (quit), NULL);
    g_signal_connect (G_OBJECT (pdata->button_scan), "clicked",G_CALLBACK (scan), NULL);
    g_signal_connect (G_OBJECT (pdata->button_connect), "clicked",G_CALLBACK (but_connect), NULL);
    g_signal_connect (G_OBJECT (pdata->button_pas), "clicked",G_CALLBACK (passcheck), NULL);
    g_signal_connect (G_OBJECT (pdata->button_pas_cancel), "clicked",G_CALLBACK (passcancel), NULL);
    g_signal_connect (G_OBJECT (pdata->button_remove), "clicked",G_CALLBACK (delprofil), NULL);
    g_signal_connect (G_OBJECT (pdata->button_set), "clicked",G_CALLBACK (addprofil), NULL);
//    g_signal_connect ((gpointer) pdata->koniec, "activate",G_CALLBACK(quit),NULL);
//    g_signal_connect ((gpointer) pdata->opcje, "activate",G_CALLBACK(opcje),NULL);
//    g_signal_connect ((gpointer) pdata->informacje, "activate",G_CALLBACK(informacje_o),NULL);
    g_signal_connect ((gpointer) pdata->comboboxentry1, "changed",G_CALLBACK (comboboxentry1_changed),NULL);
    g_signal_connect ((gpointer) pdata->comboboxentry_find, "changed",G_CALLBACK (check),NULL);
    g_signal_connect (G_OBJECT( pdata->window_pas),"delete_event",G_CALLBACK (window_pas_del), NULL);
    g_signal_connect (G_OBJECT (pdata->button_set1), "clicked",G_CALLBACK (defaultset), NULL);
    g_signal_connect (G_OBJECT (pdata->button_set2), "clicked",G_CALLBACK (saveset), NULL);
    g_signal_connect (G_OBJECT (pdata->button_set3), "clicked",G_CALLBACK (findfaceset), NULL);
//    g_signal_connect ((gpointer) pdata->checkbutton1, "toggled",G_CALLBACK (toggled),NULL);

  gtk_widget_show (pdata->vbox1);
  gtk_widget_show (pdata->label1);
  gtk_widget_show (pdata->scrolledwindow1);
  gtk_widget_show (pdata->textview1);
//  gtk_widget_show (pdata->button);
  gtk_widget_show (pdata->progresbar0);
  gtk_widget_show (pdata->progresbar1);
  gtk_widget_show (pdata->progresbar2);
  gtk_widget_show (pdata->progresbar_con);
  gtk_widget_show (pdata->notebook1);
  gtk_widget_show (pdata->zakl1);
  gtk_widget_show (pdata->info);
  gtk_widget_show (pdata->zakl_o);
  gtk_widget_show (pdata->vbox4 );
  gtk_widget_show (pdata->seting);
  gtk_widget_show (pdata->vbox2);
  gtk_widget_show (pdata->hbox1);
  gtk_widget_show (pdata->scrolledwindow2);
  gtk_widget_show (pdata->textview2);
  gtk_widget_show (pdata->comboboxentry1);
  gtk_widget_show (pdata->button_scan);
  gtk_widget_show (pdata->button_set);
  gtk_widget_show (pdata->button_remove);
  gtk_widget_show (pdata->lab_nazwa);
  gtk_widget_show (pdata->entry_nazwa);
  gtk_widget_show (pdata->lab_mode);
  gtk_widget_show (pdata->comboboxentry_mode);
  gtk_widget_show (pdata->lab_channel);
  gtk_widget_show (pdata->comboboxentry_channel);
  gtk_widget_show (pdata->hbox3);
  gtk_widget_show (pdata->comboboxentry_rate);
  gtk_widget_show (pdata->button_connect);
  gtk_widget_show (pdata->vbox3 );
  gtk_widget_show (pdata->lab_acces );
  gtk_widget_show (pdata->lab_keymode );
  gtk_widget_show (pdata->combobox_keymode );
  gtk_widget_show (pdata->lab_key );
  gtk_widget_show (pdata->lab_rate );
  gtk_widget_show (pdata->lab_gw );
  gtk_widget_show (pdata->entry_key );
  gtk_widget_show (pdata->entry_ip );
  gtk_widget_show (pdata->entry_gw );

  gtk_widget_show (pdata->vbox_pas );
  gtk_widget_show (pdata->lab_pas );
  gtk_widget_show (pdata->entry_pas );
  gtk_widget_show (pdata->button_pas);
  gtk_widget_show (pdata->hbox_pas );
  gtk_widget_show (pdata->button_pas_cancel);
  gtk_widget_show (pdata->vbox_con);
  gtk_widget_show (pdata->lab_find );
  gtk_widget_show (pdata->comboboxentry_find );

  gtk_widget_show (pdata->vbox_setting );
  gtk_widget_show (pdata->lab_set1 );
  gtk_widget_show (pdata->entry_set_iwconfig );
  gtk_widget_show (pdata->lab_set2 );
  gtk_widget_show (pdata->entry_set_iwlist );
  gtk_widget_show (pdata->lab_set3 );
  gtk_widget_show (pdata->entry_set_dhcp );
  gtk_widget_show (pdata->hbox_set1 );
  gtk_widget_show (pdata->button_set1 );
  gtk_widget_show (pdata->button_set2 );
  gtk_widget_show (pdata->zakl_setting);
  gtk_widget_show (pdata->hbox_set2 );
//  gtk_widget_show (pdata->vbox_setting2 );
  gtk_widget_show (pdata->lab_set4 );
  gtk_widget_show (pdata->entry_set_inter );
  gtk_widget_show (pdata->button_set3 );
  gtk_widget_show (pdata->lab_set5 );
  gtk_widget_show (pdata->entry_set_timescan );

  gtk_widget_show (pdata->combobox_mac );
//  gtk_widget_show (pdata->checkbutton_ip2 );
  gtk_widget_show (pdata->hbox2 );
  gtk_widget_show (pdata->hbox4 );
  gtk_widget_show (pdata->lab_ip );
  gtk_widget_show (pdata->net );
  gtk_widget_show (pdata->vbox5 );
//  gtk_widget_show (pdata->lab_inter );
//  gtk_widget_show (pdata->entry_inter );
  gtk_widget_show (pdata->lab_mac );
  gtk_widget_show (pdata->entry_mac );
  gtk_widget_show (pdata->hbox6 );
  gtk_widget_show (pdata->hbox7 );
  gtk_widget_show (pdata->hbox8 );
  gtk_widget_show (pdata->hbox_mac );
  gtk_widget_show (pdata->hbox_ip );
  gtk_widget_show (pdata->hbox_gw );
  gtk_widget_show (pdata->combobox_gw );
  gtk_widget_show (pdata->combobox_ip );
  gtk_widget_show (pdata->window);
  pdata->prostan = 0;
  pdata->stan = 0;
  textset textarg;
  textarg.window = pdata->window;
  textarg.textview1 = pdata->textview1 ;
  textarg.progresbar0=pdata->progresbar0;
  textarg.progresbar1=pdata->progresbar1;
  textarg.progresbar2=pdata->progresbar2;
  textarg.entry_inter = pdata->entry_inter ;
 // textarg.window_pas = pdata->window_pas ;
chekuser();
appendprofil();
fileread();
//chekface();
//gtk_entry_set_text (GTK_ENTRY (pdata->entry_inter),chekface());
if( (g_thread_create((GThreadFunc)textview1_function,&textarg, TRUE, &err1)) == NULL)
  {
     printf("Thread create failed: %s!!\n", err1->message );
     g_error_free ( err1 ) ;
  }

//pool1 = g_thread_pool_new (thread_pool_func, NULL, 3, FALSE, NULL);
if( (con_but = g_thread_pool_new((GFunc)conterm,NULL,1, FALSE, &err1)) == NULL)
//if( (con_but = g_thread_pool_new(conterm,NULL,1, FALSE, &err1)) == NULL)
  {
     printf("Thread create failed: %s!!\n", err1->message );
     g_error_free ( err1 ) ;
  }
    signal(SIGCHLD, sigchld_handler);/*uchwyt dla ubijania procesw*/
    gdk_threads_enter();
    gtk_main ();
    gdk_threads_leave();
    return 0;
}
